#! /usr/bin/wish -f

# AVRConfig pre0.1
#
# this program should help you configuring you libraries...
# 
# released under GPL by Johann Wilhelm oe6jwf
#

global VarList
global Notices
set Notices ""

# Sets an Variable Value
proc SetVariableValue {var value} {
	global VarList
	set  VarList($var) $value
}


# Registers a Variable ...
# returns 0 if a variable has been used mor than once else returns 1
proc RegisterVariable {var} {
	global VarList
	global Notices
	if {[lsearch [array names VarList] $var]!=-1} {
		set Notices [linsert $Notices end "// notice: $var is used more than one time"]
		return 0
	} else {
		set  VarList($var) ""
		return 1
	}
}

# make window

frame .mainframe -width 10c -height 5c
wm title . "AVRConfig 0.1"
pack .mainframe

frame .edf 

text .ed -width 80 -height 20 -bg grey \
-yscrollcommand ".ys set" 

scrollbar .ys -command ".ed yview" 
pack .ed .ys -in .edf -side left -fill y

frame .menubar -relief raised -bd 2
pack .menubar -in .mainframe -fill x
pack .edf -in .mainframe -after .menubar -fill x


# make menu

menubutton .menubar.file -text File -underline 0 -menu .menubar.file.menu
menu .menubar.file.menu
.menubar.file.menu add command -label "Save" -command { Save }

menubutton .menubar.modules -text Modules -menu .menubar.modules.menu
pack .menubar.file .menubar.modules -side left
menu .menubar.modules.menu 


# include modules and execute init-functions
cd modules
set modules [glob *]
foreach module $modules {
	source $module
	$module\_init
}

cd ..

proc Save {} {
	# output the configured variables
	global VarList
	global Notices

	set configfile [open "config.h" w+]
	foreach  notice $Notices {
		puts $configfile $notice
	}
	
	foreach  varname [array names VarList] {
		puts $configfile "#define $varname = $VarList($varname)"
	}
	
	close $configfile

}